Index: trunk/src/VBox/Additions/os2/VBoxSF/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/os2/VBoxSF/Makefile.kmk	(revision 68577)
+++ trunk/src/VBox/Additions/os2/VBoxSF/Makefile.kmk	(revision 68612)
@@ -7,7 +7,35 @@
 include $(KBUILD_PATH)/subheader.kmk
 
+VBOXSF_USE_WATCOM=1
+TEMPLATE_VBoxGuestR0Watcom = xxx
+TEMPLATE_VBoxGuestR0Watcom_EXTENDS = VBOXGUESTR0
+TEMPLATE_VBoxGuestR0Watcom_TOOL    = OPENWATCOM
+TEMPLATE_VBoxGuestR0Watcom_CTOOL   = OPENWATCOM
+TEMPLATE_VBoxGuestR0Watcom_CXXTOOL = OPENWATCOM
+TEMPLATE_VBoxGuestR0Watcom_LDTOOL  = OPENWATCOM-WL
+TEMPLATE_VBoxGuestR0Watcom_CINCS   = \
+	$(PATH_TOOL_OPENWATCOM)/h \
+	$(PATH_TOOL_OPENWATCOM)/h/os2 \
+       $(PATH_ROOT)/include \
+	/libc/svn/trunk/libc/include # for os2ddk
+TEMPLATE_VBoxGuestR0Watcom_CXXINCS = $(TEMPLATE_VBoxGuestR0Watcom_CINCS)
+TEMPLATE_VBoxGuestR0Watcom_CFLAGS  = -s  -ze -w4 -d2 -hc -nt=TEXT32 -nc=CODE -4
+TEMPLATE_VBoxGuestR0Watcom_CXXFLAGS = $(TEMPLATE_VBoxGuestR0Watcom_CFLAGS)
+
+TEMPLATE_VBoxGuestR0Watcom_LDFLAGS = \
+	form os2 lx physdevice \
+	option NODefaultlibs \
+	debug codeview all \
+	option symfile
+TEMPLATE_VBoxGuestR0Watcom_LIBS = $(NO_SUCH_VARIABLE)
+
+
 #?DLLS += VBoxSF
 SYSMODS += VBoxSF
+ifdef VBOXSF_USE_WATCOM
+VBoxSF_TEMPLATE      = VBoxGuestR0Watcom
+else
 VBoxSF_TEMPLATE      = VBOXGUESTR0
+endif
 VBoxSF_SYSSUFF       = .ifs
 VBoxSF_DLLSUFF       = .ifs
@@ -16,8 +44,77 @@
 	. \
 	$(PATH_ROOT)/src/VBox/Runtime/include
+ifdef VBOXSF_USE_WATCOM
+VBoxSF_LDFLAGS      := \
+	OPTION MODNAME='VBoxSF' \
+	SEG TYPE CODE PRELOAD DYNAMIC SHARED NONPERMANENT, \
+	    TYPE DATA PRELOAD DYNAMIC
+#	OPTION DESCRIPTION "'VirtualBox Guest Additions Shared Folder FSD for OS/2.'" - quoting issues
+# Data exports:
+VBoxSF_LDFLAGS += \
+	EXPORT 'FS_ATTRIBUTE' \
+	EXPORT 'FS_NAME' \
+	EXPORT 'FS_MPSAFEFLAGS2' \
+	EXPORT 'FS32_ATTRIBUTE'
+# 16-bit entry points.
+VBoxSF_LDFLAGS += \
+	EXPORT 'FS_ALLOCATEPAGESPACE' \
+	EXPORT 'FS_ATTACH' \
+	EXPORT 'FS_CANCELLOCKREQUEST' \
+	EXPORT 'FS_CANCELLOCKREQUESTL' \
+	EXPORT 'FS_CHDIR' \
+	EXPORT 'FS_CHGFILEPTR' \
+	EXPORT 'FS_CLOSE' \
+	EXPORT 'FS_COMMIT' \
+	EXPORT 'FS_COPY' \
+	EXPORT 'FS_DELETE' \
+	EXPORT 'FS_DOPAGEIO' \
+	EXPORT 'FS_EXIT' \
+	EXPORT 'FS_FILEATTRIBUTE' \
+	EXPORT 'FS_FILEINFO' \
+	EXPORT 'FS_FILEIO' \
+	EXPORT 'FS_FILELOCKS' \
+	EXPORT 'FS_FILELOCKSL' \
+	EXPORT 'FS_FINDCLOSE' \
+	EXPORT 'FS_FINDFIRST' \
+	EXPORT 'FS_FINDFROMNAME' \
+	EXPORT 'FS_FINDNEXT' \
+	EXPORT 'FS_FINDNOTIFYCLOSE' \
+	EXPORT 'FS_FINDNOTIFYFIRST' \
+	EXPORT 'FS_FINDNOTIFYNEXT' \
+	EXPORT 'FS_FLUSHBUF' \
+	EXPORT 'FS_FSCTL' \
+	EXPORT 'FS_FSINFO' \
+	EXPORT 'FS_INIT' \
+	EXPORT 'FS_IOCTL' \
+	EXPORT 'FS_MKDIR' \
+	EXPORT 'FS_MOUNT' \
+	EXPORT 'FS_MOVE' \
+	EXPORT 'FS_NEWSIZE' \
+	EXPORT 'FS_NEWSIZEL' \
+	EXPORT 'FS_NMPIPE' \
+	EXPORT 'FS_OPENCREATE' \
+	EXPORT 'FS_OPENPAGEFILE' \
+	EXPORT 'FS_PATHINFO' \
+	EXPORT 'FS_PROCESSNAME' \
+	EXPORT 'FS_READ' \
+	EXPORT 'FS_RMDIR' \
+	EXPORT 'FS_SETSWAP' \
+	EXPORT 'FS_SHUTDOWN' \
+	EXPORT 'FS_WRITE'
+# 32-bit entry points.
+VBoxSF_LDFLAGS += \
+	EXPORT 'FS32_CHGFILEPTR' \
+	EXPORT 'FS32_CHGFILEPTRL' \
+	EXPORT 'FS32_READ' \
+	EXPORT 'FS32_READFILEATCACHE' \
+	EXPORT 'FS32_RETURNFILECACHE' \
+	EXPORT 'FS32_WRITE'
+else
 VBoxSF_LDFLAGS      := $(addprefix -Zlinker , \
 	SEG TYPE CODE PRELOAD DYNAMIC SHARED NONPERMANENT, \
 	    TYPE DATA PRELOAD DYNAMIC)
 #VBoxSF_LDFLAGS      += -s -t -v
+endif
+
 VBoxSF_SOURCES       = \
 	VBoxSFA.asm \
@@ -25,11 +122,17 @@
 	VBoxSFFile.cpp \
 	VBoxSFFind.cpp \
-	VBoxSFInit.cpp \
+	VBoxSFInit.cpp
+ifndef VBOXSF_USE_WATCOM
+ VBoxSF_SOURCES     += \
 	VBoxSF.def
+endif
 VBoxSF_LIBS          = \
 	$(VBOX_LIB_VBGL_R0) \
-	$(VBOX_LIB_IPRT_GUEST_R0) \
-	$(VBOX_GCC_LIBGCC) \
-	end
+	$(VBOX_LIB_IPRT_GUEST_R0)
+ifdef VBOXSF_USE_WATCOM
+ VBoxSF_LIBS        += $(PATH_IGCC)/lib/libend.lib
+else
+ VBoxSF_LIBS        += end
+endif
 
 include $(FILE_KBUILD_SUB_FOOTER)
Index: trunk/src/VBox/Additions/os2/VBoxSF/VBoxSF.cpp
===================================================================
--- trunk/src/VBox/Additions/os2/VBoxSF/VBoxSF.cpp	(revision 68577)
+++ trunk/src/VBox/Additions/os2/VBoxSF/VBoxSF.cpp	(revision 68612)
@@ -44,4 +44,5 @@
 FS32_EXIT(ULONG uid, ULONG pid, ULONG pdb)
 {
+    NOREF(uid); NOREF(pid); NOREF(pdb);
 }
 
@@ -50,4 +51,5 @@
 FS32_SHUTDOWN(ULONG type, ULONG reserved)
 {
+    NOREF(type); NOREF(reserved);
     return NO_ERROR;
 }
@@ -55,6 +57,7 @@
 
 DECLASM(int)
-FS32_ATTACH(ULONG flag, PCSZ pszDev, PVBOXSFVP pvpfsd, PVBOXSFCD pcdfsd, PBYTE pszParm, PUSHORT pcbParm)
+FS32_ATTACH(ULONG fFlags, PCSZ pszDev, PVBOXSFVP pvpfsd, PVBOXSFCD pcdfsd, PBYTE pszParm, PUSHORT pcbParm)
 {
+    NOREF(fFlags); NOREF(pszDev); NOREF(pvpfsd); NOREF(pcdfsd); NOREF(pszParm); NOREF(pcbParm);
     return ERROR_NOT_SUPPORTED;
 }
@@ -62,6 +65,7 @@
 
 DECLASM(int)
-FS32_FLUSHBUF(USHORT hVPB, ULONG flag)
+FS32_FLUSHBUF(USHORT hVPB, ULONG fFlags)
 {
+    NOREF(hVPB); NOREF(fFlags);
     return NO_ERROR;
 }
@@ -69,6 +73,7 @@
 
 DECLASM(int)
-FS32_FSINFO(ULONG flag, USHORT hVPB, PBYTE pbData, USHORT cbData, ULONG level)
+FS32_FSINFO(ULONG fFlags, USHORT hVPB, PBYTE pbData, USHORT cbData, ULONG uLevel)
 {
+    NOREF(fFlags); NOREF(hVPB); NOREF(pbData); NOREF(cbData); NOREF(uLevel);
     return ERROR_NOT_SUPPORTED;
 }
@@ -76,8 +81,10 @@
 
 DECLASM(int)
-FS32_FSCTL(union argdat *pArgdat, ULONG iArgType, ULONG func,
-           PVOID pParm, USHORT lenParm, PUSHORT plenParmIO,
-           PVOID pData, USHORT lenData, PUSHORT plenDataIO)
+FS32_FSCTL(union argdat *pArgdat, ULONG iArgType, ULONG uFunction,
+           PVOID pvParm, USHORT cbParm, PUSHORT pcbParmIO,
+           PVOID pvData, USHORT cbData, PUSHORT pcbDataIO)
 {
+    NOREF(pArgdat); NOREF(iArgType); NOREF(uFunction); NOREF(pvParm); NOREF(cbParm); NOREF(pcbParmIO);
+    NOREF(pvData); NOREF(cbData); NOREF(pcbDataIO);
     return ERROR_NOT_SUPPORTED;
 }
@@ -87,4 +94,5 @@
 FS32_PROCESSNAME(PSZ pszName)
 {
+    NOREF(pszName);
     return NO_ERROR;
 }
@@ -92,6 +100,7 @@
 
 DECLASM(int)
-FS32_CHDIR(ULONG flag, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszDir, USHORT iCurDirEnd)
+FS32_CHDIR(ULONG fFlags, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszDir, USHORT iCurDirEnd)
 {
+    NOREF(fFlags); NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszDir); NOREF(iCurDirEnd);
     return ERROR_NOT_SUPPORTED;
 }
@@ -99,7 +108,8 @@
 
 DECLASM(int)
-FS32_MKDIR(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd,
-           PBYTE pEABuf, ULONG flag)
+FS32_MKDIR(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszDir, USHORT iCurDirEnd,
+           PBYTE pbEABuf, ULONG fFlags)
 {
+    NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszDir); NOREF(iCurDirEnd); NOREF(pbEABuf); NOREF(fFlags);
     return ERROR_NOT_SUPPORTED;
 }
@@ -107,6 +117,7 @@
 
 DECLASM(int)
-FS32_RMDIR(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd)
+FS32_RMDIR(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszDir, USHORT iCurDirEnd)
 {
+    NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszDir); NOREF(iCurDirEnd);
     return ERROR_NOT_SUPPORTED;
 }
@@ -114,7 +125,9 @@
 
 DECLASM(int)
-FS32_COPY(USHORT flag, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszSrc, USHORT iSrcCurDirEnd,
-          PCSZ pszDst, USHORT iDstCurDirEnd, USHORT nameType)
+FS32_COPY(USHORT fFlags, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszSrc, USHORT iSrcCurDirEnd,
+          PCSZ pszDst, USHORT iDstCurDirEnd, USHORT uNameType)
 {
+    NOREF(fFlags); NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszSrc); NOREF(iSrcCurDirEnd);
+    NOREF(pszDst); NOREF(iDstCurDirEnd); NOREF(uNameType);
     return ERROR_NOT_SUPPORTED;
 }
@@ -123,6 +136,7 @@
 DECLASM(int)
 FS32_MOVE(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszSrc, USHORT iSrcCurDirEnd,
-          PCSZ pszDst, USHORT iDstCurDirEnd, USHORT type)
+          PCSZ pszDst, USHORT iDstCurDirEnd, USHORT uNameType)
 {
+    NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszSrc); NOREF(iSrcCurDirEnd); NOREF(pszDst); NOREF(iDstCurDirEnd); NOREF(uNameType);
     return ERROR_NOT_SUPPORTED;
 }
@@ -132,4 +146,5 @@
 FS32_DELETE(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszFile, USHORT iCurDirEnd)
 {
+    NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszFile); NOREF(iCurDirEnd);
     return ERROR_NOT_SUPPORTED;
 }
@@ -137,6 +152,7 @@
 
 DECLASM(int)
-FS32_FILEATTRIBUTE(ULONG flag, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd, PUSHORT pAttr)
+FS32_FILEATTRIBUTE(ULONG fFlags, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd, PUSHORT pfAttr)
 {
+    NOREF(fFlags); NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszName); NOREF(iCurDirEnd); NOREF(pfAttr);
     return ERROR_NOT_SUPPORTED;
 }
@@ -144,7 +160,8 @@
 
 DECLASM(int)
-FS32_PATHINFO(USHORT flag, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnt,
-              USHORT level, PBYTE pData, USHORT cbData)
+FS32_PATHINFO(USHORT fFlags, PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd,
+              USHORT uLevel, PBYTE pbData, USHORT cbData)
 {
+    NOREF(fFlags); NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszName); NOREF(iCurDirEnd); NOREF(uLevel); NOREF(pbData); NOREF(cbData);
     return ERROR_NOT_SUPPORTED;
 }
@@ -152,6 +169,7 @@
 
 DECLASM(int)
-FS32_MOUNT(USHORT flag, PVPFSI pvpfsi, PVBOXSFVP pvpfsd, USHORT hVPB, PCSZ pszBoot)
+FS32_MOUNT(USHORT fFlags, PVPFSI pvpfsi, PVBOXSFVP pvpfsd, USHORT hVPB, PCSZ pszBoot)
 {
+    NOREF(fFlags); NOREF(pvpfsi); NOREF(pvpfsd); NOREF(hVPB); NOREF(pszBoot);
     return ERROR_NOT_SUPPORTED;
 }
Index: trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFFile.cpp
===================================================================
--- trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFFile.cpp	(revision 68577)
+++ trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFFile.cpp	(revision 68612)
@@ -43,28 +43,33 @@
 DECLASM(int)
 FS32_OPENCREATE(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd,
-                PSFFSI psffsi, PVBOXSFFSD psffsd, ULONG ulOpenMode, USHORT usOpenFlag,
-                PUSHORT pusAction, USHORT usAttr, PBYTE pcEABuf, PUSHORT pfgenflag)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-DECLASM(int)
-FS32_CLOSE(ULONG type, ULONG IOflag, PSFFSI psffsi, PVBOXSFFSD psffsd)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-DECLASM(int)
-FS32_COMMIT(ULONG type, ULONG IOflag, PSFFSI psffsi, PVBOXSFFSD psffsd)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-extern "C" APIRET APIENTRY
-FS32_CHGFILEPTRL(PSFFSI psffsi, PVBOXSFFSD psffsd, LONGLONG off, ULONG ulMethod, ULONG IOflag)
-{
+                PSFFSI psffsi, PVBOXSFFSD psffsd, ULONG uOpenMode, USHORT fOpenFlag,
+                PUSHORT puAction, USHORT fAttr, PBYTE pbEABuf, PUSHORT pfGenFlag)
+{
+    NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszName); NOREF(iCurDirEnd); NOREF(psffsi); NOREF(psffsd); NOREF(uOpenMode);
+    NOREF(fOpenFlag); NOREF(puAction); NOREF(fAttr); NOREF(pbEABuf); NOREF(pfGenFlag);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+DECLASM(int)
+FS32_CLOSE(ULONG uType, ULONG fIoFlags, PSFFSI psffsi, PVBOXSFFSD psffsd)
+{
+    NOREF(uType); NOREF(fIoFlags); NOREF(psffsi); NOREF(psffsd);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+DECLASM(int)
+FS32_COMMIT(ULONG uType, ULONG fIoFlags, PSFFSI psffsi, PVBOXSFFSD psffsd)
+{
+    NOREF(uType); NOREF(fIoFlags); NOREF(psffsi); NOREF(psffsd);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+extern "C" APIRET APIENTRY
+FS32_CHGFILEPTRL(PSFFSI psffsi, PVBOXSFFSD psffsd, LONGLONG off, ULONG uMethod, ULONG fIoFlags)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(off); NOREF(uMethod); NOREF(fIoFlags);
     return ERROR_NOT_SUPPORTED;
 }
@@ -73,40 +78,45 @@
 /** Forwards the call to FS32_CHGFILEPTRL. */
 extern "C" APIRET APIENTRY
-FS32_CHGFILEPTR(PSFFSI psffsi, PVBOXSFFSD psffsd, LONG off, ULONG ulMethod, ULONG IOflag)
-{
-    return FS32_CHGFILEPTRL(psffsi, psffsd, off, ulMethod, IOflag);
-}
-
-DECLASM(int)
-FS32_FILEINFO(ULONG flag, PSFFSI psffsi, PVBOXSFFSD psffsd, ULONG level,
-              PBYTE pData, ULONG cbData, ULONG IOflag)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-DECLASM(int)
-FS32_NEWSIZEL(PSFFSI psffsi, PVBOXSFFSD psffsd, LONGLONG cbFile, ULONG IOflag)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-extern "C" APIRET APIENTRY
-FS32_READ(PSFFSI psffsi, PVBOXSFFSD psffsd, PVOID pvData, PULONG pcb, ULONG IOflag)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-extern "C" APIRET APIENTRY
-FS32_WRITE(PSFFSI psffsi, PVBOXSFFSD psffsd, PVOID pvData, PULONG pcb, ULONG IOflag)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-extern "C" APIRET APIENTRY
-FS32_READFILEATCACHE(PSFFSI psffsi, PVBOXSFFSD psffsd, ULONG IOflag, LONGLONG off, ULONG pcb, KernCacheList_t **ppCacheList)
-{
+FS32_CHGFILEPTR(PSFFSI psffsi, PVBOXSFFSD psffsd, LONG off, ULONG uMethod, ULONG fIoFlags)
+{
+    return FS32_CHGFILEPTRL(psffsi, psffsd, off, uMethod, fIoFlags);
+}
+
+DECLASM(int)
+FS32_FILEINFO(ULONG fFlag, PSFFSI psffsi, PVBOXSFFSD psffsd, ULONG uLevel,
+              PBYTE pbData, ULONG cbData, ULONG fIoFlags)
+{
+    NOREF(fFlag); NOREF(psffsi); NOREF(psffsd); NOREF(uLevel); NOREF(pbData); NOREF(cbData); NOREF(fIoFlags);
+    return ERROR_NOT_SUPPORTED;
+}
+
+DECLASM(int)
+FS32_NEWSIZEL(PSFFSI psffsi, PVBOXSFFSD psffsd, LONGLONG cbFile, ULONG fIoFlags)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(cbFile); NOREF(fIoFlags);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+extern "C" APIRET APIENTRY
+FS32_READ(PSFFSI psffsi, PVBOXSFFSD psffsd, PVOID pvData, PULONG pcb, ULONG fIoFlags)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(pvData); NOREF(pcb); NOREF(fIoFlags);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+extern "C" APIRET APIENTRY
+FS32_WRITE(PSFFSI psffsi, PVBOXSFFSD psffsd, PVOID pvData, PULONG pcb, ULONG fIoFlags)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(pvData); NOREF(pcb); NOREF(fIoFlags);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+extern "C" APIRET APIENTRY
+FS32_READFILEATCACHE(PSFFSI psffsi, PVBOXSFFSD psffsd, ULONG fIoFlags, LONGLONG off, ULONG pcb, KernCacheList_t **ppCacheList)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(fIoFlags); NOREF(off); NOREF(pcb); NOREF(ppCacheList);
     return ERROR_NOT_SUPPORTED;
 }
@@ -116,4 +126,5 @@
 FS32_RETURNFILECACHE(KernCacheList_t *pCacheList)
 {
+    NOREF(pCacheList);
     return ERROR_NOT_SUPPORTED;
 }
@@ -125,4 +136,5 @@
 FS32_CANCELLOCKREQUESTL(PSFFSI psffsi, PVBOXSFFSD psffsd, struct filelockl *pLockRange)
 {
+    NOREF(psffsi); NOREF(psffsd); NOREF(pLockRange);
     return ERROR_NOT_SUPPORTED;
 }
@@ -132,4 +144,5 @@
 FS32_CANCELLOCKREQUEST(PSFFSI psffsi, PVBOXSFFSD psffsd, struct filelock *pLockRange)
 {
+    NOREF(psffsi); NOREF(psffsd); NOREF(pLockRange);
     return ERROR_NOT_SUPPORTED;
 }
@@ -138,6 +151,7 @@
 DECLASM(int)
 FS32_FILELOCKSL(PSFFSI psffsi, PVBOXSFFSD psffsd, struct filelockl *pUnLockRange,
-                struct filelockl *pLockRange, ULONG timeout, ULONG flags)
-{
+                struct filelockl *pLockRange, ULONG cMsTimeout, ULONG fFlags)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(pUnLockRange); NOREF(pLockRange); NOREF(cMsTimeout); NOREF(fFlags);
     return ERROR_NOT_SUPPORTED;
 }
@@ -146,39 +160,46 @@
 DECLASM(int)
 FS32_FILELOCKS(PSFFSI psffsi, PVBOXSFFSD psffsd, struct filelock *pUnLockRange,
-               struct filelock *pLockRange, ULONG timeout, ULONG flags)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-DECLASM(int)
-FS32_IOCTL(PSFFSI psffsi, PVBOXSFFSD psffsd, USHORT cat, USHORT func,
-           PVOID pParm, USHORT lenParm, PUSHORT plenParmIO,
-           PVOID pData, USHORT lenData, PUSHORT plenDataIO)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-DECLASM(int)
-FS32_FILEIO(PSFFSI psffsi, PVBOXSFFSD psffsd, PBYTE pCmdList, USHORT cbCmdList,
-            PUSHORT poError, USHORT IOflag)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-DECLASM(int)
-FS32_NMPIPE(PSFFSI psffsi, PVBOXSFFSD psffsd, USHORT OpType, union npoper *pOpRec,
-            PBYTE pData, PCSZ pszName)
-{
-    return ERROR_NOT_SUPPORTED;
-}
-
-
-DECLASM(int)
-FS32_OPENPAGEFILE(PULONG pFlag, PULONG pcMaxReq, PCSZ pszName, PSFFSI psffsi, PVBOXSFFSD psffsd,
-                  USHORT ulOpenMode, USHORT usOpenFlag, USHORT usAttr, ULONG Reserved)
-{
+               struct filelock *pLockRange, ULONG cMsTimeout, ULONG fFlags)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(pUnLockRange); NOREF(pLockRange); NOREF(cMsTimeout); NOREF(fFlags);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+DECLASM(int)
+FS32_IOCTL(PSFFSI psffsi, PVBOXSFFSD psffsd, USHORT uCategory, USHORT uFunction,
+           PVOID pvParm, USHORT cbParm, PUSHORT pcbParmIO,
+           PVOID pvData, USHORT cbData, PUSHORT pcbDataIO)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(uCategory); NOREF(uFunction); NOREF(pvParm); NOREF(cbParm); NOREF(pcbParmIO);
+    NOREF(pvData); NOREF(cbData); NOREF(pcbDataIO);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+DECLASM(int)
+FS32_FILEIO(PSFFSI psffsi, PVBOXSFFSD psffsd, PBYTE pbCmdList, USHORT cbCmdList,
+            PUSHORT poffError, USHORT fIoFlag)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(pbCmdList); NOREF(cbCmdList); NOREF(poffError); NOREF(fIoFlag);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+DECLASM(int)
+FS32_NMPIPE(PSFFSI psffsi, PVBOXSFFSD psffsd, USHORT uOpType, union npoper *pOpRec,
+            PBYTE pbData, PCSZ pszName)
+{
+    NOREF(psffsi); NOREF(psffsd); NOREF(uOpType); NOREF(pOpRec); NOREF(pbData); NOREF(pszName);
+    return ERROR_NOT_SUPPORTED;
+}
+
+
+DECLASM(int)
+FS32_OPENPAGEFILE(PULONG pfFlags, PULONG pcMaxReq, PCSZ pszName, PSFFSI psffsi, PVBOXSFFSD psffsd,
+                  USHORT uOpenMode, USHORT fOpenFlags, USHORT fAttr, ULONG uReserved)
+{
+    NOREF(pfFlags); NOREF(pcMaxReq); NOREF(pszName); NOREF(psffsi); NOREF(psffsd); NOREF(uOpenMode); NOREF(fOpenFlags);
+    NOREF(fAttr); NOREF(uReserved);
     return ERROR_NOT_SUPPORTED;
 }
@@ -188,4 +209,5 @@
 FS32_SETSWAP(PSFFSI psffsi, PVBOXSFFSD psffsd)
 {
+    NOREF(psffsi); NOREF(psffsd);
     return ERROR_NOT_SUPPORTED;
 }
@@ -195,4 +217,5 @@
 FS32_ALLOCATEPAGESPACE(PSFFSI psffsi, PVBOXSFFSD psffsd, ULONG cb, USHORT cbWantContig)
 {
+    NOREF(psffsi); NOREF(psffsd); NOREF(cb); NOREF(cbWantContig);
     return ERROR_NOT_SUPPORTED;
 }
@@ -202,5 +225,6 @@
 FS32_DOPAGEIO(PSFFSI psffsi, PVBOXSFFSD psffsd, struct PageCmdHeader *pList)
 {
-    return ERROR_NOT_SUPPORTED;
-}
-
+    NOREF(psffsi); NOREF(psffsd); NOREF(pList);
+    return ERROR_NOT_SUPPORTED;
+}
+
Index: trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFFind.cpp
===================================================================
--- trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFFind.cpp	(revision 68577)
+++ trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFFind.cpp	(revision 68612)
@@ -41,8 +41,10 @@
 
 DECLASM(int)
-FS32_FINDFIRST(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd, USHORT attr,
+FS32_FINDFIRST(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd, USHORT fAttr,
                PFSFSI pfsfsi, PVBOXSFFS pfsfsd, PBYTE pbData, USHORT cbData, PUSHORT pcMatch,
-               USHORT level, USHORT flags)
+               USHORT uLevel, USHORT fFlags)
 {
+    NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszName); NOREF(iCurDirEnd); NOREF(fAttr); NOREF(pfsfsi); NOREF(pfsfsd); NOREF(pbData);
+    NOREF(cbData); NOREF(pcMatch); NOREF(uLevel); NOREF(fFlags);
     return ERROR_NOT_SUPPORTED;
 }
@@ -51,6 +53,8 @@
 DECLASM(int)
 FS32_FINDFROMNAME(PFSFSI pfsfsi, PVBOXSFFS pfsfsd, PBYTE pbData, USHORT cbData, PUSHORT pcMatch,
-                  USHORT level, ULONG position, PCSZ pszName, USHORT flag)
+                  USHORT uLevel, ULONG position, PCSZ pszName, USHORT fFlags)
 {
+    NOREF(pfsfsi); NOREF(pfsfsd); NOREF(pbData); NOREF(cbData); NOREF(pcMatch); NOREF(uLevel); NOREF(position); NOREF(pszName);
+    NOREF(fFlags);
     return ERROR_NOT_SUPPORTED;
 }
@@ -59,6 +63,7 @@
 DECLASM(int)
 FS32_FINDNEXT(PFSFSI pfsfsi, PVBOXSFFS pfsfsd, PBYTE pbData, USHORT cbData, PUSHORT pcMatch,
-              USHORT level, USHORT flag)
+              USHORT uLevel, USHORT fFlags)
 {
+    NOREF(pfsfsi); NOREF(pfsfsd); NOREF(pbData); NOREF(cbData); NOREF(pcMatch); NOREF(uLevel); NOREF(fFlags);
     return ERROR_NOT_SUPPORTED;
 }
@@ -68,4 +73,5 @@
 FS32_FINDCLOSE(PFSFSI pfsfsi, PVBOXSFFS pfsfsd)
 {
+    NOREF(pfsfsi); NOREF(pfsfsd);
     return ERROR_NOT_SUPPORTED;
 }
@@ -76,8 +82,10 @@
 
 DECLASM(int)
-FS32_FINDNOTIFYFIRST(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd, USHORT attr,
-                     PUSHORT pHandle, PBYTE pbData, USHORT cbData, PUSHORT pcMatch,
-                     USHORT level, USHORT flags)
+FS32_FINDNOTIFYFIRST(PCDFSI pcdfsi, PVBOXSFCD pcdfsd, PCSZ pszName, USHORT iCurDirEnd, USHORT fAtt,
+                     PUSHORT phHandle, PBYTE pbData, USHORT cbData, PUSHORT pcMatch,
+                     USHORT uLevel, USHORT fFlags)
 {
+    NOREF(pcdfsi); NOREF(pcdfsd); NOREF(pszName); NOREF(iCurDirEnd); NOREF(fAtt); NOREF(phHandle); NOREF(pbData); NOREF(cbData);
+    NOREF(pcMatch); NOREF(uLevel); NOREF(fFlags);
     return ERROR_NOT_SUPPORTED;
 }
@@ -85,7 +93,8 @@
 
 DECLASM(int)
-FS32_FINDNOTIFYNEXT(USHORT handle, PBYTE pbData, USHORT cbData, PUSHORT pcMatch,
-                    USHORT level, ULONG timeout)
+FS32_FINDNOTIFYNEXT(USHORT hHandle, PBYTE pbData, USHORT cbData, PUSHORT pcMatch,
+                    USHORT uLevel, ULONG cMsTimeout)
 {
+    NOREF(hHandle); NOREF(pbData); NOREF(cbData); NOREF(pcMatch); NOREF(uLevel); NOREF(cMsTimeout);
     return ERROR_NOT_SUPPORTED;
 }
@@ -93,6 +102,7 @@
 
 DECLASM(int)
-FS32_FINDNOTIFYCLOSE(USHORT handle)
+FS32_FINDNOTIFYCLOSE(USHORT hHandle)
 {
+    NOREF(hHandle);
     return ERROR_NOT_SUPPORTED;
 }
Index: trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFInternal.h
===================================================================
--- trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFInternal.h	(revision 68577)
+++ trunk/src/VBox/Additions/os2/VBoxSF/VBoxSFInternal.h	(revision 68612)
@@ -35,4 +35,5 @@
 #define INCL_BASE
 #define INCL_ERROR
+#define INCL_LONGLONG
 #include <os2.h>
 #include <os2ddk/bsekee.h>