Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBGLR3Internal.h
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBGLR3Internal.h	(revision 68649)
+++ 	(revision )
@@ -1,119 +1,0 @@
-/* $Id$ */
-/** @file
- * VBoxGuestR3Lib - Ring-3 support library for the guest additions, Internal header.
- */
-
-/*
- * Copyright (C) 2006-2016 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * The contents of this file may alternatively be used under the terms
- * of the Common Development and Distribution License Version 1.0
- * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
- * VirtualBox OSE distribution, in which case the provisions of the
- * CDDL are applicable instead of those of the GPL.
- *
- * You may elect to license modified versions of this file under the
- * terms and conditions of either the GPL or the CDDL or both.
- */
-
-#ifndef ___VBGLR3Internal_h
-#define ___VBGLR3Internal_h
-
-#if defined(RT_OS_WINDOWS) /** @todo explain why this is here. */
-# include <iprt/win/windows.h>
-#endif
-#include <VBox/VMMDev.h>
-#include <VBox/VBoxGuest.h>
-#include <VBox/VBoxGuestLib.h>
-
-#ifdef VBOX_VBGLR3_XFREE86
-/* Rather than try to resolve all the header file conflicts, I will just
-   prototype what we need here. */
-typedef unsigned long xf86size_t;
-extern "C" xf86size_t xf86strlen(const char*);
-# undef strlen
-# define strlen xf86strlen
-#endif /* VBOX_VBGLR3_XFREE86 */
-
-RT_C_DECLS_BEGIN
-
-int     vbglR3DoIOCtl(uintptr_t uFunction, PVBGLREQHDR pReq, size_t cbReq);
-int     vbglR3DoIOCtlRaw(uintptr_t uFunction, PVBGLREQHDR pReq, size_t cbReq);
-int     vbglR3GRAlloc(VMMDevRequestHeader **ppReq, size_t cb, VMMDevRequestType enmReqType);
-int     vbglR3GRPerform(VMMDevRequestHeader *pReq);
-void    vbglR3GRFree(VMMDevRequestHeader *pReq);
-
-
-
-DECLINLINE(void) VbglHGCMParmUInt32Set(HGCMFunctionParameter *pParm, uint32_t u32)
-{
-    pParm->type = VMMDevHGCMParmType_32bit;
-    pParm->u.value64 = 0; /* init unused bits to 0 */
-    pParm->u.value32 = u32;
-}
-
-
-DECLINLINE(int) VbglHGCMParmUInt32Get(HGCMFunctionParameter *pParm, uint32_t *pu32)
-{
-    if (pParm->type == VMMDevHGCMParmType_32bit)
-    {
-        *pu32 = pParm->u.value32;
-        return VINF_SUCCESS;
-    }
-    return VERR_INVALID_PARAMETER;
-}
-
-
-DECLINLINE(void) VbglHGCMParmUInt64Set(HGCMFunctionParameter *pParm, uint64_t u64)
-{
-    pParm->type      = VMMDevHGCMParmType_64bit;
-    pParm->u.value64 = u64;
-}
-
-
-DECLINLINE(int) VbglHGCMParmUInt64Get(HGCMFunctionParameter *pParm, uint64_t *pu64)
-{
-    if (pParm->type == VMMDevHGCMParmType_64bit)
-    {
-        *pu64 = pParm->u.value64;
-        return VINF_SUCCESS;
-    }
-    return VERR_INVALID_PARAMETER;
-}
-
-
-DECLINLINE(void) VbglHGCMParmPtrSet(HGCMFunctionParameter *pParm, void *pv, uint32_t cb)
-{
-    pParm->type                    = VMMDevHGCMParmType_LinAddr;
-    pParm->u.Pointer.size          = cb;
-    pParm->u.Pointer.u.linearAddr  = (uintptr_t)pv;
-}
-
-
-#ifdef ___iprt_string_h
-
-DECLINLINE(void) VbglHGCMParmPtrSetString(HGCMFunctionParameter *pParm, const char *psz)
-{
-    pParm->type                    = VMMDevHGCMParmType_LinAddr_In;
-    pParm->u.Pointer.size          = (uint32_t)strlen(psz) + 1;
-    pParm->u.Pointer.u.linearAddr  = (uintptr_t)psz;
-}
-
-#endif /* ___iprt_string_h */
-
-#ifdef VBOX_VBGLR3_XFREE86
-# undef strlen
-#endif /* VBOX_VBGLR3_XFREE86 */
-
-RT_C_DECLS_END
-
-#endif
-
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3Lib.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3Lib.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3Lib.cpp	(revision 68650)
@@ -64,5 +64,5 @@
 #include <iprt/thread.h>
 #include <VBox/log.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 #ifdef VBOX_VBGLR3_XFREE86
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibAdditions.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibAdditions.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibAdditions.cpp	(revision 68650)
@@ -34,5 +34,5 @@
 #include <VBox/log.h>
 #include <VBox/version.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibAutoLogon.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibAutoLogon.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibAutoLogon.cpp	(revision 68650)
@@ -34,5 +34,5 @@
 #endif
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibBalloon.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibBalloon.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibBalloon.cpp	(revision 68650)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 #include <iprt/string.h>
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibClipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibClipboard.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibClipboard.cpp	(revision 68650)
@@ -32,5 +32,5 @@
 #include <iprt/assert.h>
 #include <iprt/string.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCoreDump.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCoreDump.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCoreDump.cpp	(revision 68650)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCpuHotPlug.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCpuHotPlug.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCpuHotPlug.cpp	(revision 68650)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCredentials.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCredentials.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibCredentials.cpp	(revision 68650)
@@ -35,5 +35,5 @@
 #include <VBox/log.h>
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDaemonize.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDaemonize.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDaemonize.cpp	(revision 68650)
@@ -54,5 +54,5 @@
 #include <iprt/process.h>
 #include <iprt/string.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDragAndDrop.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDragAndDrop.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDragAndDrop.cpp	(revision 68650)
@@ -50,5 +50,5 @@
 using namespace DragAndDropSvc;
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibEvent.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibEvent.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibEvent.cpp	(revision 68650)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <VBox/log.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGR.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGR.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGR.cpp	(revision 68650)
@@ -33,5 +33,5 @@
 #include <iprt/string.h>
 #include <iprt/err.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestCtrl.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestCtrl.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestCtrl.cpp	(revision 68650)
@@ -37,5 +37,5 @@
 #include <VBox/HostServices/GuestControlSvc.h>
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 using namespace guestControl;
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestProp.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestProp.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestProp.cpp	(revision 68650)
@@ -42,5 +42,5 @@
 #include <VBox/HostServices/GuestPropertySvc.h>
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 #ifdef VBOX_VBGLR3_XFREE86
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestUser.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestUser.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibGuestUser.cpp	(revision 68650)
@@ -35,5 +35,5 @@
 #include <iprt/string.h>
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHGCM.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHGCM.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHGCM.cpp	(revision 68650)
@@ -30,5 +30,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 #include <VBox/VBoxGuestLib.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHostChannel.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHostChannel.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHostChannel.cpp	(revision 68650)
@@ -30,5 +30,5 @@
 #include <VBox/HostServices/VBoxHostChannel.h>
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHostVersion.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHostVersion.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibHostVersion.cpp	(revision 68650)
@@ -38,5 +38,5 @@
 #endif
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 /**
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibInternal.h
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibInternal.h	(revision 68650)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibInternal.h	(revision 68650)
@@ -0,0 +1,119 @@
+/* $Id$ */
+/** @file
+ * VBoxGuestR3Lib - Ring-3 support library for the guest additions, Internal header.
+ */
+
+/*
+ * Copyright (C) 2006-2016 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+#ifndef ___VBGLR3Internal_h
+#define ___VBGLR3Internal_h
+
+#if defined(RT_OS_WINDOWS) /** @todo explain why this is here. */
+# include <iprt/win/windows.h>
+#endif
+#include <VBox/VMMDev.h>
+#include <VBox/VBoxGuest.h>
+#include <VBox/VBoxGuestLib.h>
+
+#ifdef VBOX_VBGLR3_XFREE86
+/* Rather than try to resolve all the header file conflicts, I will just
+   prototype what we need here. */
+typedef unsigned long xf86size_t;
+extern "C" xf86size_t xf86strlen(const char*);
+# undef strlen
+# define strlen xf86strlen
+#endif /* VBOX_VBGLR3_XFREE86 */
+
+RT_C_DECLS_BEGIN
+
+int     vbglR3DoIOCtl(uintptr_t uFunction, PVBGLREQHDR pReq, size_t cbReq);
+int     vbglR3DoIOCtlRaw(uintptr_t uFunction, PVBGLREQHDR pReq, size_t cbReq);
+int     vbglR3GRAlloc(VMMDevRequestHeader **ppReq, size_t cb, VMMDevRequestType enmReqType);
+int     vbglR3GRPerform(VMMDevRequestHeader *pReq);
+void    vbglR3GRFree(VMMDevRequestHeader *pReq);
+
+
+
+DECLINLINE(void) VbglHGCMParmUInt32Set(HGCMFunctionParameter *pParm, uint32_t u32)
+{
+    pParm->type = VMMDevHGCMParmType_32bit;
+    pParm->u.value64 = 0; /* init unused bits to 0 */
+    pParm->u.value32 = u32;
+}
+
+
+DECLINLINE(int) VbglHGCMParmUInt32Get(HGCMFunctionParameter *pParm, uint32_t *pu32)
+{
+    if (pParm->type == VMMDevHGCMParmType_32bit)
+    {
+        *pu32 = pParm->u.value32;
+        return VINF_SUCCESS;
+    }
+    return VERR_INVALID_PARAMETER;
+}
+
+
+DECLINLINE(void) VbglHGCMParmUInt64Set(HGCMFunctionParameter *pParm, uint64_t u64)
+{
+    pParm->type      = VMMDevHGCMParmType_64bit;
+    pParm->u.value64 = u64;
+}
+
+
+DECLINLINE(int) VbglHGCMParmUInt64Get(HGCMFunctionParameter *pParm, uint64_t *pu64)
+{
+    if (pParm->type == VMMDevHGCMParmType_64bit)
+    {
+        *pu64 = pParm->u.value64;
+        return VINF_SUCCESS;
+    }
+    return VERR_INVALID_PARAMETER;
+}
+
+
+DECLINLINE(void) VbglHGCMParmPtrSet(HGCMFunctionParameter *pParm, void *pv, uint32_t cb)
+{
+    pParm->type                    = VMMDevHGCMParmType_LinAddr;
+    pParm->u.Pointer.size          = cb;
+    pParm->u.Pointer.u.linearAddr  = (uintptr_t)pv;
+}
+
+
+#ifdef ___iprt_string_h
+
+DECLINLINE(void) VbglHGCMParmPtrSetString(HGCMFunctionParameter *pParm, const char *psz)
+{
+    pParm->type                    = VMMDevHGCMParmType_LinAddr_In;
+    pParm->u.Pointer.size          = (uint32_t)strlen(psz) + 1;
+    pParm->u.Pointer.u.linearAddr  = (uintptr_t)psz;
+}
+
+#endif /* ___iprt_string_h */
+
+#ifdef VBOX_VBGLR3_XFREE86
+# undef strlen
+#endif /* VBOX_VBGLR3_XFREE86 */
+
+RT_C_DECLS_END
+
+#endif
+
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibLog.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibLog.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibLog.cpp	(revision 68650)
@@ -31,5 +31,5 @@
 #include <iprt/mem.h>
 #include <iprt/string.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibMisc.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibMisc.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibMisc.cpp	(revision 68650)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <VBox/log.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibModule.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibModule.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibModule.cpp	(revision 68650)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 #include <iprt/mem.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibMouse.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibMouse.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibMouse.cpp	(revision 68650)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibPidFile.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibPidFile.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibPidFile.cpp	(revision 68650)
@@ -33,5 +33,5 @@
 #include <iprt/string.h>
 #include <iprt/process.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 /**
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibSeamless.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibSeamless.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibSeamless.cpp	(revision 68650)
@@ -34,5 +34,5 @@
 #include <VBox/log.h>
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 #ifdef VBOX_VBGLR3_XFREE86
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibSharedFolders.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibSharedFolders.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibSharedFolders.cpp	(revision 68650)
@@ -37,5 +37,5 @@
 #include <VBox/shflsvc.h> /** @todo File should be moved to VBox/HostServices/SharedFolderSvc.h */
 
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibStat.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibStat.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibStat.cpp	(revision 68650)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibTime.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibTime.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibTime.cpp	(revision 68650)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/time.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibVideo.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibVideo.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibVideo.cpp	(revision 68650)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 #include <VBox/log.h>
Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibVrdp.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibVrdp.cpp	(revision 68649)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibVrdp.cpp	(revision 68650)
@@ -31,5 +31,5 @@
 #include <iprt/time.h>
 #include <iprt/string.h>
-#include "VBGLR3Internal.h"
+#include "VBoxGuestR3LibInternal.h"
 
 