Index: trunk/include/VBox/Graphics/HGSMI.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMI.h	(revision 68670)
+++ trunk/include/VBox/Graphics/HGSMI.h	(revision 68672)
@@ -1,6 +1,4 @@
 /** @file
- *
- * VBox Host Guest Shared Memory Interface (HGSMI).
- * Host/Guest shared part.
+ * VBox Host Guest Shared Memory Interface (HGSMI) - Host/Guest shared part.
  */
 
@@ -31,9 +29,9 @@
 #define ___VBox_Graphics_HGSMI_h
 
-#include <VBoxVideoIPRT.h>
-
-#include <HGSMIDefs.h>
-#include <HGSMIChannels.h>
-#include <HGSMIMemAlloc.h>
+#include "VBoxVideoIPRT.h"
+
+#include "HGSMIDefs.h"
+#include "HGSMIChannels.h"
+#include "HGSMIMemAlloc.h"
 
 /*
Index: trunk/include/VBox/Graphics/HGSMIBase.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIBase.h	(revision 68670)
+++ trunk/include/VBox/Graphics/HGSMIBase.h	(revision 68672)
@@ -1,4 +1,4 @@
 /** @file
- * VBox Host Guest Shared Memory Interface (HGSMI) buffer management.
+ * VBox Host Guest Shared Memory Interface (HGSMI) - buffer management.
  */
 
@@ -28,7 +28,7 @@
 #define ___VBox_Graphics_HGSMIBase_h___
 
-#include <HGSMI.h>
-#include <HGSMIContext.h>
-#include <VBoxVideoIPRT.h>
+#include "HGSMI.h"
+#include "HGSMIContext.h"
+#include "VBoxVideoIPRT.h"
 
 RT_C_DECLS_BEGIN
Index: trunk/include/VBox/Graphics/HGSMIChSetup.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIChSetup.h	(revision 68670)
+++ trunk/include/VBox/Graphics/HGSMIChSetup.h	(revision 68672)
@@ -1,4 +1,4 @@
 /** @file
- * VBox Host Guest Shared Memory Interface (HGSMI), sHost/Guest shared part.
+ * VBox Host Guest Shared Memory Interface (HGSMI), Host/Guest shared part.
  */
 
@@ -27,4 +27,6 @@
 #ifndef ___VBox_Graphics_HGSMIChSetup_h
 #define ___VBox_Graphics_HGSMIChSetup_h
+
+#include "HGSMIDefs.h"
 
 /* HGSMI setup and configuration channel commands and data structures. */
Index: trunk/include/VBox/Graphics/HGSMIContext.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIContext.h	(revision 68670)
+++ trunk/include/VBox/Graphics/HGSMIContext.h	(revision 68672)
@@ -1,4 +1,4 @@
 /** @file
- * VBox Host Guest Shared Memory Interface (HGSMI) command contexts.
+ * VBox Host Guest Shared Memory Interface (HGSMI) - command contexts.
  */
 
@@ -28,7 +28,7 @@
 #define ___VBox_Graphics_HGSMIContext_h___
 
-#include <HGSMI.h>
-#include <HGSMIChSetup.h>
-#include <VBoxVideoIPRT.h>
+#include "HGSMI.h"
+#include "HGSMIChSetup.h"
+#include "VBoxVideoIPRT.h"
 
 #ifdef VBOX_WDDM_MINIPORT
@@ -105,2 +105,3 @@
 
 #endif
+
Index: trunk/include/VBox/Graphics/HGSMIDefs.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIDefs.h	(revision 68670)
+++ trunk/include/VBox/Graphics/HGSMIDefs.h	(revision 68672)
@@ -1,6 +1,4 @@
 /** @file
- *
- * VBox Host Guest Shared Memory Interface (HGSMI).
- * Host/Guest shared part: types and defines.
+ * VBox Host Guest Shared Memory Interface (HGSMI) - shared part - types and defines.
  */
 
@@ -31,5 +29,5 @@
 #define ___VBox_Graphics_HGSMIDefs_h
 
-#include <VBoxVideoIPRT.h>
+#include "VBoxVideoIPRT.h"
 
 /* HGSMI uses 32 bit offsets and sizes. */
@@ -61,5 +59,5 @@
 
 
-#pragma pack(1)
+#pragma pack(1) /** @todo not necessary. use AssertCompileSize instead. */
 /* 16 bytes buffer header. */
 typedef struct HGSMIBUFFERHEADER
@@ -122,2 +120,3 @@
 
 #endif /* !___VBox_Graphics_HGSMIDefs_h */
+
Index: trunk/include/VBox/Graphics/HGSMIHostCmd.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIHostCmd.h	(revision 68670)
+++ trunk/include/VBox/Graphics/HGSMIHostCmd.h	(revision 68672)
@@ -1,4 +1,4 @@
 /** @file
- * VBox Host Guest Shared Memory Interface (HGSMI) buffer management.
+ * VBox Host Guest Shared Memory Interface (HGSMI) - buffer management.
  */
 
@@ -28,7 +28,7 @@
 #define ___VBox_Graphics_HGSMIHostCmd_h___
 
-#include <HGSMI.h>
-#include <HGSMIContext.h>
-#include <VBoxVideoIPRT.h>
+#include "HGSMI.h"
+#include "HGSMIContext.h"
+#include "VBoxVideoIPRT.h"
 
 RT_C_DECLS_BEGIN
Index: trunk/include/VBox/Graphics/HGSMIMemAlloc.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIMemAlloc.h	(revision 68670)
+++ trunk/include/VBox/Graphics/HGSMIMemAlloc.h	(revision 68672)
@@ -1,6 +1,4 @@
 /** @file
- *
- * VBox Host Guest Shared Memory Interface (HGSMI).
- * Memory allocator.
+ * VBox Host Guest Shared Memory Interface (HGSMI) - Memory allocator.
  */
 
@@ -30,6 +28,6 @@
 #define ___VBox_Graphics_HGSMIMemAlloc_h
 
-#include <HGSMIDefs.h>
-#include <VBoxVideoIPRT.h>
+#include "HGSMIDefs.h"
+#include "VBoxVideoIPRT.h"
 
 
Index: trunk/include/VBox/Graphics/VBoxCrHgsmi.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxCrHgsmi.h	(revision 68670)
+++ trunk/include/VBox/Graphics/VBoxCrHgsmi.h	(revision 68672)
@@ -1,2 +1,6 @@
+/** @file
+ * Document me, pretty please.
+ */
+
 /*
  * Copyright (C) 2010-2016 Oracle Corporation
@@ -23,5 +27,5 @@
 
 #include <iprt/cdefs.h>
-#include <VBoxUhgsmi.h>
+#include "VBoxUhgsmi.h"
 
 RT_C_DECLS_BEGIN
Index: trunk/include/VBox/Graphics/VBoxVideoGuest.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideoGuest.h	(revision 68670)
+++ trunk/include/VBox/Graphics/VBoxVideoGuest.h	(revision 68672)
@@ -1,5 +1,4 @@
 /** @file
- * VBox Host Guest Shared Memory Interface (HGSMI).
- * OS-independent guest structures.
+ * VBox Host Guest Shared Memory Interface (HGSMI) - OS-independent guest structures.
  */
 
@@ -30,7 +29,7 @@
 #define ___VBox_Graphics_VBoxVideoGuest_h___
 
-#include <HGSMIBase.h>
-#include <VBoxVideo.h>
-#include <VBoxVideoIPRT.h>
+#include "HGSMIBase.h"
+#include "VBoxVideo.h"
+#include "VBoxVideoIPRT.h"
 
 RT_C_DECLS_BEGIN
Index: trunk/include/VBox/Graphics/VBoxVideoIPRT.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideoIPRT.h	(revision 68670)
+++ trunk/include/VBox/Graphics/VBoxVideoIPRT.h	(revision 68672)
@@ -1,5 +1,4 @@
 /** @file
- * VirtualBox Video driver, common code - iprt and VirtualBox macros and
- * definitions.
+ * VirtualBox Video driver, common code - iprt and VirtualBox macros and definitions.
  */
 