Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 68678)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 68679)
@@ -2033,13 +2033,4 @@
              "least <b>%1</b> of video memory.</p>")
              .arg(VBoxGlobal::formatSize(uMinVRAM)));
-}
-
-void UIMessageCenter::cannotMountGuestAdditions(const QString &strMachineName) const
-{
-    alert(0, MessageType_Error,
-          tr("<p>Could not insert the <b>VirtualBox Guest Additions</b> disk image file into the virtual machine <b>%1</b>, "
-             "as the machine has no optical drives. Please add a drive using the storage page of the "
-             "virtual machine settings window.</p>")
-             .arg(strMachineName));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 68678)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 68679)
@@ -312,5 +312,4 @@
     bool cannotSwitchScreenInFullscreen(quint64 uMinVRAM) const;
     void cannotSwitchScreenInSeamless(quint64 uMinVRAM) const;
-    void cannotMountGuestAdditions(const QString &strMachineName) const;
     void cannotAddDiskEncryptionPassword(const CConsole &console);
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp	(revision 68678)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp	(revision 68679)
@@ -629,2 +629,30 @@
 }
 
+void UIPopupCenter::cannotMountImage(QWidget *pParent, const QString &strMachineName, const QString &strMediumName)
+{
+    alert(pParent, "cannotMountImage",
+          QApplication::translate("UIMessageCenter",
+                                  "<p>Could not insert the <b>%1</b> disk image file into the virtual machine <b>%2</b>, "
+                                  "as the machine has no optical drives. Please add a drive using the storage page of the "
+                                  "virtual machine settings window.</p>")
+                                  .arg(strMediumName, strMachineName));
+}
+
+void UIPopupCenter::cannotOpenMedium(QWidget *pParent, const CVirtualBox &comVBox, UIMediumType /* enmType */, const QString &strLocation)
+{
+    alertWithDetails(pParent, "cannotOpenMedium",
+                     QApplication::translate("UIMessageCenter",
+                                             "Failed to open the disk image file <nobr><b>%1</b></nobr>.")
+                                             .arg(strLocation),
+                     UIErrorString::formatErrorInfo(comVBox));
+}
+
+void UIPopupCenter::cannotSaveMachineSettings(QWidget *pParent, const CMachine &comMachine)
+{
+    alertWithDetails(pParent, "cannotSaveMachineSettings",
+                     QApplication::translate("UIMessageCenter",
+                                             "Failed to save the settings of the virtual machine <b>%1</b> to <b><nobr>%2</nobr></b>.")
+                                             .arg(CMachine(comMachine).GetName(), CMachine(comMachine).GetSettingsFilePath()),
+                     UIErrorString::formatErrorInfo(comMachine));
+}
+
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.h	(revision 68678)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.h	(revision 68679)
@@ -24,4 +24,7 @@
 #include <QPointer>
 
+/* GUI includes: */
+#include "UIMediumDefs.h"
+
 /* Forward declaration: */
 class QWidget;
@@ -32,4 +35,5 @@
 class CMachine;
 class CNetworkAdapter;
+class CVirtualBox;
 class CVirtualBoxErrorInfo;
 class CVRDEServer;
@@ -138,4 +142,7 @@
     void cannotToggleAudioInput(QWidget *pParent, const CAudioAdapter &comAdapter,
                                 const QString &strMachineName, bool fEnable);
+    void cannotMountImage(QWidget *pParent, const QString &strMachineName, const QString &strMediumName);
+    void cannotOpenMedium(QWidget *pParent, const CVirtualBox &comVBox, UIMediumType enmType, const QString &strLocation);
+    void cannotSaveMachineSettings(QWidget *pParent, const CMachine &comMachine);
 
 private slots:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 68678)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 68679)
@@ -1892,5 +1892,5 @@
         if (!comVBox.isOk() || comMedium.isNull())
         {
-            msgCenter().cannotOpenMedium(comVBox, enmMediumType, strMediumName);
+            popupCenter().cannotOpenMedium(machineLogic()->activeMachineWindow(), comVBox, enmMediumType, strMediumName);
             return false;
         }
@@ -1935,5 +1935,5 @@
     if (sStorageSlots.isEmpty())
     {
-        msgCenter().cannotMountGuestAdditions(machineName());
+        popupCenter().cannotMountImage(machineLogic()->activeMachineWindow(), machineName(), strMediumName);
         return false;
     }
@@ -1961,5 +1961,5 @@
     if (!machine().isOk())
     {
-        msgCenter().cannotSaveMachineSettings(machine(), mainMachineWindow());
+        popupCenter().cannotSaveMachineSettings(machineLogic()->activeMachineWindow(), machine());
         return false;
     }