Index: trunk/include/VBox/Graphics/HGSMIChSetup.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIChSetup.h	(revision 68847)
+++ trunk/include/VBox/Graphics/HGSMIChSetup.h	(revision 68848)
@@ -31,9 +31,10 @@
 
 /* HGSMI setup and configuration channel commands and data structures. */
-#define HGSMI_CC_HOST_FLAGS_LOCATION 0 /* Tell the host the location of HGSMIHOSTFLAGS structure,
-                                        * where the host can write information about pending
-                                        * buffers, etc, and which can be quickly polled by
-                                        * the guest without a need to port IO.
-                                        */
+/*
+ * Tell the host the location of hgsmi_host_flags structure, where the host
+ * can write information about pending buffers, etc, and which can be quickly
+ * polled by the guest without a need to port IO.
+ */
+#define HGSMI_CC_HOST_FLAGS_LOCATION 0
 
 typedef struct HGSMIBUFFERLOCATION
@@ -46,12 +47,12 @@
 /* HGSMI setup and configuration data structures. */
 /* host->guest commands pending, should be accessed under FIFO lock only */
-#define HGSMIHOSTFLAGS_COMMANDS_PENDING    UINT32_C(0x1)
+#define HGSMIHOSTFLAGS_COMMANDS_PENDING    UINT32_C(0x01)
 /* IRQ is fired, should be accessed under VGAState::lock only  */
-#define HGSMIHOSTFLAGS_IRQ                 UINT32_C(0x2)
+#define HGSMIHOSTFLAGS_IRQ                 UINT32_C(0x02)
 #ifdef VBOX_WITH_WDDM
 /* one or more guest commands is completed, should be accessed under FIFO lock only */
-# define HGSMIHOSTFLAGS_GCOMMAND_COMPLETED UINT32_C(0x4)
+# define HGSMIHOSTFLAGS_GCOMMAND_COMPLETED UINT32_C(0x04)
 /* watchdog timer interrupt flag (used for debugging), should be accessed under VGAState::lock only */
-# define HGSMIHOSTFLAGS_WATCHDOG           UINT32_C(0x8)
+# define HGSMIHOSTFLAGS_WATCHDOG           UINT32_C(0x08)
 #endif
 /* vsync interrupt flag, should be accessed under VGAState::lock only */
@@ -59,15 +60,20 @@
 /** monitor hotplug flag, should be accessed under VGAState::lock only */
 #define HGSMIHOSTFLAGS_HOTPLUG             UINT32_C(0x20)
-/** Cursor capability state change flag, should be accessed under
- * VGAState::lock only.  @see VBVACONF32. */
+/**
+ * Cursor capability state change flag, should be accessed under
+ * VGAState::lock only.  @see VBVACONF32.
+ */
 #define HGSMIHOSTFLAGS_CURSOR_CAPABILITIES UINT32_C(0x40)
 
 typedef struct HGSMIHOSTFLAGS
 {
-    /* host flags can be accessed and modified in multiple threads concurrently,
-     * e.g. CrOpenGL HGCM and GUI threads when to completing HGSMI 3D and Video Accel respectively,
-     * EMT thread when dealing with HGSMI command processing, etc.
-     * Besides settings/cleaning flags atomically, some each flag has its own special sync restrictions,
-     * see commants for flags definitions above */
+    /*
+     * Host flags can be accessed and modified in multiple threads
+     * concurrently, e.g. CrOpenGL HGCM and GUI threads when completing
+     * HGSMI 3D and Video Accel respectively, EMT thread when dealing with
+     * HGSMI command processing, etc.
+     * Besides settings/cleaning flags atomically, some flags have their
+     * own special sync restrictions, see comments for flags above.
+     */
     volatile uint32_t u32HostFlags;
     uint32_t au32Reserved[3];
@@ -76,3 +82,2 @@
 
 #endif
-
Index: trunk/include/VBox/Graphics/HGSMIChannels.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIChannels.h	(revision 68847)
+++ trunk/include/VBox/Graphics/HGSMIChannels.h	(revision 68848)
@@ -33,5 +33,6 @@
 
 
-/* Each channel has an 8 bit identifier. There are a number of predefined
+/*
+ * Each channel has an 8 bit identifier. There are a number of predefined
  * (hardcoded) channels.
  *
@@ -39,25 +40,30 @@
  * to a free 16 bit numerical value. values are allocated in range
  * [HGSMI_CH_STRING_FIRST;HGSMI_CH_STRING_LAST].
- *
  */
 
 
 /* Predefined channel identifiers. Used internally by VBOX to simplify the channel setup. */
-#define HGSMI_CH_RESERVED     (0x00) /* A reserved channel value. */
-
-#define HGSMI_CH_HGSMI        (0x01) /* HGCMI: setup and configuration channel. */
-
-#define HGSMI_CH_VBVA         (0x02) /* Graphics: VBVA. */
-#define HGSMI_CH_SEAMLESS     (0x03) /* Graphics: Seamless with a single guest region. */
-#define HGSMI_CH_SEAMLESS2    (0x04) /* Graphics: Seamless with separate host windows. */
-#define HGSMI_CH_OPENGL       (0x05) /* Graphics: OpenGL HW acceleration. */
+/* A reserved channel value */
+#define HGSMI_CH_RESERVED     0x00
+/* HGCMI: setup and configuration */
+#define HGSMI_CH_HGSMI        0x01
+/* Graphics: VBVA */
+#define HGSMI_CH_VBVA         0x02
+/* Graphics: Seamless with a single guest region */
+#define HGSMI_CH_SEAMLESS     0x03
+/* Graphics: Seamless with separate host windows */
+#define HGSMI_CH_SEAMLESS2    0x04
+/* Graphics: OpenGL HW acceleration */
+#define HGSMI_CH_OPENGL       0x05
 
 
 /* Dynamically allocated channel identifiers. */
-#define HGSMI_CH_STRING_FIRST (0x20) /* The first channel index to be used for string mappings (inclusive). */
-#define HGSMI_CH_STRING_LAST  (0xff) /* The last channel index for string mappings (inclusive). */
+/* The first channel index to be used for string mappings (inclusive) */
+#define HGSMI_CH_STRING_FIRST 0x20
+/* The last channel index for string mappings (inclusive) */
+#define HGSMI_CH_STRING_LAST  0xff
 
 
-/* Check whether the channel identifier is allocated for a dynamic channel. */
+/* Check whether the channel identifier is allocated for a dynamic channel */
 #define HGSMI_IS_DYNAMIC_CHANNEL(_channel) (((uint8_t)(_channel) & 0xE0) != 0)
 
Index: trunk/include/VBox/Graphics/VBoxVideoGuest.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideoGuest.h	(revision 68847)
+++ trunk/include/VBox/Graphics/VBoxVideoGuest.h	(revision 68848)
@@ -29,7 +29,7 @@
 #define ___VBox_Graphics_VBoxVideoGuest_h___
 
+#include "VBoxVideoIPRT.h"
 #include "HGSMIBase.h"
 #include "VBoxVideo.h"
-#include "VBoxVideoIPRT.h"
 
 RT_C_DECLS_BEGIN